import json
from datetime import datetime
from server.data_processing.process_lidar_data import height_in_area

# input_new_Lidar_data send new data gathered from the lidar and send it to the database (from the drone, most likely)
def input_new_Lidar_data(self, cursor, sensorId, bodyOfWater):
    try:
        # create a new measurement with the time the data is sent, sensor type, where
        # and an estimate of average thickness of ice on water body
        cursor.execute('''
            INSERT INTO Measurement(  SensorID, TimeMeasured, WaterBodyName, WholeAverageThickness) VALUES 
                (?,?,?,?);
        ''', ( sensorId, datetime.utcnow().replace(microsecond=0), bodyOfWater, 0))

        # auto generate new measurement id
        measurement_id = cursor.lastrowid

        # input the newly generated measurement_id and ... average thickness (soon to be implemented)
        cursor.execute('''
            UPDATE Measurement
            SET measurementID = ?
            WHERE MeasurementID IS NULL;
        ''', (int(measurement_id),))

        # soon to be removed
        cursor.execute('''
            SELECT CenterLatitude, CenterLongitude, SubDivisionID, GroupID
            FROM SubDivision
            GROUP BY CenterLatitude, CenterLongitude
        ''')
        position_data = cursor.fetchall()

        # soon to be removed
        if(position_data):
            for row in position_data:
                latitude, longitude, subID, groupID = row
                heights = height_in_area((latitude,longitude))
                if(len(heights) > 0):
                    print(heights)
                else:
                    print("No height found")
                average = sum(heights)/len(heights)
                cursor.execute('''
                INSERT INTO SubDivision(MeasurementID, SubDivisionID, GroupID, MinimumThickness, AverageThickness, CenterLatitude, CenterLongitude, Accuracy) VALUES
                    (?,?,?,?,?,?,?,?);
                ''',(measurement_id, subID, groupID, float(min(heights)), float(average), float(latitude), float(longitude), float(1)))
        else:
            print('No data')

        # send the changes to the database
        cursor.connection.commit()

        print("suc_ceed")

    # error handling
    except Exception as e:
        print("An error occurred", e)
        # rollback in case of error
        cursor.connection.rollback()